Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3337)
@@ -27,4 +27,8 @@
 ! -----------------
 ! $Id$
+! (from branch resler)
+! Formatting
+! 
+! 3312 2018-10-06 14:15:46Z knoop
 ! Initial revision
 !
@@ -719,7 +723,8 @@
                 DO  ispec = 1 , len_index
 
-                   IF ( emiss_factor_main(match_spec_input(ispec)) .LT. 0 .AND. emiss_factor_side(match_spec_input(ispec)) .LT. 0 ) THEN
-
-                      message_string = 'PARAMETERIZED emissions mode selected:'            //          &
+                   IF ( emiss_factor_main(match_spec_input(ispec)) .LT. 0 .AND.                         &
+                        emiss_factor_side(match_spec_input(ispec)) .LT. 0 ) THEN
+
+                      message_string = 'PARAMETERIZED emissions mode selected:'            //           &
                                        ' EMISSIONS POSSIBLE ONLY ON STREET SURFACES'        //          &
                                        ' but values of scaling factors for street types'    //          &
@@ -1246,13 +1251,17 @@
                 IF (TRIM(spc_names(match_spec_model(ispec)))=="NO") THEN
                 !>             Kg/m2                       kg/m2*s                                                    
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%nox_comp(icat,1)*con_factor
+                   delta_emis(nys:nyn,nxl:nxr) =                                                             &
+                         emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%nox_comp(icat,1)*con_factor
                    
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                              &
+                         emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
 
                 ELSE IF (TRIM(spc_names(match_spec_model(ispec)))=="NO2") THEN
    
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%nox_comp(icat,2)*con_factor
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
+                   delta_emis(nys:nyn,nxl:nxr) =                                                             &
+                         emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%nox_comp(icat,2)*con_factor
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                              &
+                         emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
  
              !> SOX Compositions
@@ -1260,13 +1269,17 @@
                 ELSE IF (TRIM(spc_names(match_spec_model(ispec)))=="SO2") THEN
                       
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%sox_comp(icat,1)*con_factor
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
+                   delta_emis(nys:nyn,nxl:nxr) =                                                             &
+                         emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%sox_comp(icat,1)*con_factor
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                              &
+                         emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
 
                 ELSE IF (TRIM(spc_names(match_spec_model(ispec)))=="SO4") THEN
    
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%sox_comp(icat,2)*con_factor
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
+                   delta_emis(nys:nyn,nxl:nxr) =                                                             &
+                         emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%sox_comp(icat,2)*con_factor
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                              &
+                         emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
  
 
@@ -1278,8 +1291,10 @@
                    DO i_pm_comp= 1,SIZE(emt_att%pm_comp(1,:,1))
 
-                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%pm_comp(icat,i_pm_comp,1)*con_factor 
+                      delta_emis(nys:nyn,nxl:nxr) =                                                          &
+                            emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%pm_comp(icat,i_pm_comp,1)*con_factor
                                                                                          
 
-                      emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
+                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                           &
+                            emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
  
                    ENDDO
@@ -1291,8 +1306,10 @@
                    DO i_pm_comp= 1,SIZE(emt_att%pm_comp(1,:,2))
 
-                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%pm_comp(icat,i_pm_comp,2)*con_factor 
+                      delta_emis(nys:nyn,nxl:nxr) =                                                          &
+                            emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%pm_comp(icat,i_pm_comp,2)*con_factor
                                                                                          
 
-                      emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
+                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                           &
+                            emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
  
                    ENDDO
@@ -1304,8 +1321,10 @@
                    DO i_pm_comp= 1,SIZE(emt_att%pm_comp(1,:,3))  
                        
-                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%pm_comp(icat,i_pm_comp,3)*con_factor 
+                      delta_emis(nys:nyn,nxl:nxr) =                                                          &
+                            emis(nys:nyn,nxl:nxr)*time_factor(icat)*emt_att%pm_comp(icat,i_pm_comp,3)*con_factor
                                                                                                  
 
-                      emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr) 
+                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                           &
+                            emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
 
                    ENDDO
@@ -1319,8 +1338,9 @@
                       IF (TRIM(spc_names(match_spec_model(ispec)))==TRIM(emt_att%voc_name(ivoc))) THEN    
 
-                         delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*                               &
+                         delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*               &
                                                        emt_att%voc_comp(icat,match_spec_voc_input(ivoc))*con_factor
 
-                         emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr) 
+                         emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                         &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
 
                       ENDIF                       
@@ -1333,5 +1353,6 @@
                    delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr)*time_factor(icat)*con_factor
  
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr) 
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                               &
+                         emis_distribution(1,nys:nyn,nxl:nxr,ispec)+delta_emis(nys:nyn,nxl:nxr)
 
                 ENDIF  ! IF (spc_names==)
@@ -1375,5 +1396,6 @@
 
                          !> PMs are already in mass units:micrograms:they have to be converted to kilograms 
-                         IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
+                         IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1"         &
+                             .OR.  TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
                              .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
 
@@ -1389,9 +1411,9 @@
                          !> Other Species: inputs are micromoles: they have to be converted in moles
                          !                 ppm/s *m *kg/m^3                
-                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_main(match_spec_input(ispec))*   &
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_main(match_spec_input(ispec))*  &
                          !                                                    micromoles/(m^2*s)
-                                                                          emis_distribution(1,j,i,ispec) *              &
+                                                                          emis_distribution(1,j,i,ispec) *             &
                          !                                                    m**3/Nmole
-                                                                          conv_to_ratio(k,j,i)*                         &       
+                                                                          conv_to_ratio(k,j,i)*                        &
                          !                                                    kg/m^3
                                                                           rho_air(k)   
@@ -1403,5 +1425,6 @@
 
 
-                   ELSEIF ( street_type_f%var(j,i) >= side_street_id  .AND. street_type_f%var(j,i) < main_street_id )  THEN
+                   ELSEIF ( street_type_f%var(j,i) >= side_street_id  .AND.                                            &
+                            street_type_f%var(j,i) < main_street_id )  THEN
 
                    !> Cycle over already matched species
@@ -1409,9 +1432,10 @@
 
                          !> PMs are already in mass units: micrograms
-                         IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
+                         IF (     TRIM(spc_names(match_spec_model(ispec)))=="PM1"   &
+                             .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
                              .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
 
                             !              kg/(m^2*s) *kg/m^3                               
-                            surf_lsm_h%cssws(match_spec_model(ispec),m)= emiss_factor_side(match_spec_input(ispec)) *   &
+                            surf_lsm_h%cssws(match_spec_model(ispec),m)= emiss_factor_side(match_spec_input(ispec)) *  &
                             !                                                       kg/(m^2*s)
                                                                                 emis_distribution(1,j,i,ispec)*        &
@@ -1423,9 +1447,9 @@
                          !>Other Species: inputs are micromoles
                          !                 ppm/s *m *kg/m^3                
-                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_side(match_spec_input(ispec)) *   &
+                            surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_side(match_spec_input(ispec)) * &
                          !                                                    micromoles/(m^2*s)
-                                                                          emis_distribution(1,j,i,ispec) *              &
+                                                                          emis_distribution(1,j,i,ispec) *             &
                          !                                                    m**3/Nmole
-                                                                          conv_to_ratio(k,j,i)*                         &       
+                                                                          conv_to_ratio(k,j,i)*                        &
                          !                                                    kg/m^3
                                                                           rho_air(k)   
@@ -1466,6 +1490,7 @@
 
                    !> PMs
-                   IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
-                          .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
+                   IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1"                                   &
+                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"                           &
+                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
                    
                       !            kg/(m^2*s) *kg/m^3                         kg/(m^2*s)                 
@@ -1522,6 +1547,7 @@
 
                    !> PMs
-                   IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
-                          .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
+                   IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1"                                            &
+                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"                                    &
+                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
 
                       !         kg/(m^2*s) * kg/m^3                           kg/(m^2*s)            
@@ -1573,6 +1599,7 @@
 
                    !> PMs
-                   IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1" .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"  &
-                          .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
+                   IF (TRIM(spc_names(match_spec_model(ispec)))=="PM1"                                     &
+                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM25"                             &
+                         .OR. TRIM(spc_names(match_spec_model(ispec)))=="PM10") THEN
                    
                       !          kg/(m^2*s) *kg/m^3                             kg/(m^2*s)                     
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 3322)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 3337)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! (from branch resler)
+! Add Biometeorology
+! 
+! 3294 2018-10-01 02:37:10Z raasch
 ! changes concerning modularization of ocean option
 ! 
@@ -269,4 +273,7 @@
     USE radiation_model_mod,                                                   &
         ONLY:  nzub, nzut, radiation, radiation_data_output_3d
+
+    USE biometeorology_mod,                                                    &
+        ONLY: biometeorology_data_output_3d
 
     USE turbulence_closure_mod,                                                &
@@ -744,4 +751,12 @@
              IF ( .NOT. found  .AND.  radiation )  THEN
                 CALL radiation_data_output_3d( av, do3d(av,if), found,         &
+                                               local_pf, nzb_do, nzt_do )
+                resorted = .TRUE.
+             ENDIF
+
+!
+!--          Biometeorology quantity
+             IF ( .NOT. found  .AND.  radiation )  THEN
+                CALL biometeorology_data_output_3d( av, do3d(av,if), found,    &
                                                local_pf, nzb_do, nzt_do )
                 resorted = .TRUE.
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 3322)
+++ palm/trunk/SOURCE/modules.f90	(revision 3337)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! (from branch resler)
+! Increase dimension of uv_heights etc.
+! 
+! 3302 2018-10-03 02:39:40Z raasch
 ! +u/v_stokes_zu, u/v_stokes_zw
 ! 
@@ -1566,7 +1570,7 @@
     REAL(wp) ::  tsc(10) = (/ 1.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, &    !< array used for controlling time-integration at different substeps
                  0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp /)
-    REAL(wp) ::  u_profile(100) = 9999999.9_wp                     !< namelist parameter
-    REAL(wp) ::  uv_heights(100) = 9999999.9_wp                    !< namelist parameter
-    REAL(wp) ::  v_profile(100) = 9999999.9_wp                     !< namelist parameter
+    REAL(wp) ::  u_profile(200) = 9999999.9_wp                     !< namelist parameter
+    REAL(wp) ::  uv_heights(200) = 9999999.9_wp                    !< namelist parameter
+    REAL(wp) ::  v_profile(200) = 9999999.9_wp                     !< namelist parameter
     REAL(wp) ::  ug_vertical_gradient(10) = 0.0_wp                 !< namelist parameter
     REAL(wp) ::  ug_vertical_gradient_level(10) = -9999999.9_wp    !< namelist parameter
Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3337)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! (from branch resler)
+! Formatting
+! 
+! 3298 2018-10-02 12:21:11Z kanani
 ! Modified EXPERT mode to PRE-PROCESSED mode (Russo)
 ! Introduced Chemistry static netcdf file (Russo)
@@ -1030,5 +1034,6 @@
                 ALLOCATE(emt_att%hourly_emis_time_factor(1:emt_att%ncat,1:emt_att%nhoursyear))
                 !Read-in Variable
-                CALL get_variable(id_emis,"emission_time_factors",emt_att%hourly_emis_time_factor,1,emt_att%ncat,1,emt_att%nhoursyear)
+                CALL get_variable(id_emis,"emission_time_factors",emt_att%hourly_emis_time_factor,1,   &
+                                  emt_att%ncat,1,emt_att%nhoursyear)
 
                 !-- MDH
@@ -1038,5 +1043,6 @@
                 ALLOCATE(emt_att%mdh_emis_time_factor(1:emt_att%ncat,1:emt_att%nmonthdayhour))
                 !-- Read-in Variable
-                CALL get_variable(id_emis,"emission_time_factors",emt_att%mdh_emis_time_factor,1,emt_att%ncat,1,emt_att%nmonthdayhour)
+                CALL get_variable(id_emis,"emission_time_factors",emt_att%mdh_emis_time_factor,1,       &
+                                  emt_att%ncat,1,emt_att%nmonthdayhour)
 
              ELSE
@@ -1055,5 +1061,6 @@
              DO ispec=1,emt_att%nspec
 
-                IF ( .NOT. ALLOCATED( emt(ispec)%default_emission_data ) ) ALLOCATE(emt(ispec)%default_emission_data(1:emt_att%ncat,1:ny+1,1:nx+1))
+                IF ( .NOT. ALLOCATED( emt(ispec)%default_emission_data ) )                              &
+                    ALLOCATE(emt(ispec)%default_emission_data(1:emt_att%ncat,1:ny+1,1:nx+1))
 
                 ALLOCATE(dum_var_3d(1:emt_att%ncat,nys+1:nyn+1,nxl+1:nxr+1))
@@ -1061,5 +1068,6 @@
                 CALL get_variable(id_emis,"emission_values",dum_var_3d,ispec,1,emt_att%ncat,nys,nyn,nxl,nxr)          
 
-                emt(ispec)%default_emission_data(:,nys+1:nyn+1,nxl+1:nxr+1)=dum_var_3d(1:emt_att%ncat,nys+1:nyn+1,nxl+1:nxr+1)
+                emt(ispec)%default_emission_data(:,nys+1:nyn+1,nxl+1:nxr+1) =                           &
+                    dum_var_3d(1:emt_att%ncat,nys+1:nyn+1,nxl+1:nxr+1)
 
                 DEALLOCATE (dum_var_3d)
@@ -1105,5 +1113,6 @@
 
                 !Allocation for the entire domain has to be done only for the first processor between all the subdomains     
-                IF ( .NOT. ALLOCATED( emt(ispec)%preproc_emission_data ) ) ALLOCATE(emt(ispec)%preproc_emission_data(emt_att%dt_emission,1,1:ny+1,1:nx+1)) 
+                IF ( .NOT. ALLOCATED( emt(ispec)%preproc_emission_data ) )                              &
+                    ALLOCATE(emt(ispec)%preproc_emission_data(emt_att%dt_emission,1,1:ny+1,1:nx+1))
 
                 !> allocate variable where to pass emission values read from netcdf
@@ -1114,5 +1123,6 @@
 
       
-                emt(ispec)%preproc_emission_data(:,1,nys+1:nyn+1,nxl+1:nxr+1)=dum_var_4d(1:emt_att%dt_emission,1,nys+1:nyn+1,nxl+1:nxr+1)
+                emt(ispec)%preproc_emission_data(:,1,nys+1:nyn+1,nxl+1:nxr+1) =                         &
+                      dum_var_4d(1:emt_att%dt_emission,1,nys+1:nyn+1,nxl+1:nxr+1)
 
                 DEALLOCATE ( dum_var_4d )
Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3337)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! (from branch resler)
+! Add biometeorology
+! 
+! 3294 2018-10-01 02:37:10Z raasch
 ! changes concerning modularization of ocean option
 ! 
@@ -610,4 +614,7 @@
         ONLY: radiation, radiation_define_netcdf_grid
 
+    USE biometeorology_mod,                                                    &
+        ONLY: biometeorology_define_netcdf_grid
+
     USE spectra_mod,                                                           &
         ONLY:  averaging_interval_sp, comp_spectra_level, data_output_sp, dosp_time_count, spectra_direction
@@ -1016,4 +1023,11 @@
                                                          grid_z )
                    ENDIF
+!
+!--                Check for biometeorology quantities
+                   IF ( .NOT. found  .AND.  radiation )  THEN
+                      CALL biometeorology_define_netcdf_grid( domask(mid,av,i),&
+                                                         found, grid_x, grid_y,&
+                                                         grid_z )
+                   ENDIF
 
                    CALL tcm_define_netcdf_grid( domask( mid,av,i), found,      &
@@ -1545,9 +1559,17 @@
                                                    grid_y, grid_z )
                    ENDIF
-                   
+
 !
 !--                Check for radiation quantities
                    IF ( .NOT. found  .AND.  radiation )  THEN
                       CALL radiation_define_netcdf_grid( do3d(av,i), found,    &
+                                                         grid_x, grid_y,       &
+                                                         grid_z )
+                   ENDIF
+
+!
+!--                Check for biometeorology quantities
+                   IF ( .NOT. found  .AND.  radiation )  THEN
+                      CALL biometeorology_define_netcdf_grid( do3d(av,i), found,&
                                                          grid_x, grid_y,       &
                                                          grid_z )
@@ -2322,4 +2344,12 @@
 
 !
+!--                      Check for biometeorology quantities
+                         IF ( .NOT. found  .AND.  radiation )  THEN
+                            CALL biometeorology_define_netcdf_grid( do2d(av,i),&
+                                                         found, grid_x, grid_y,&
+                                                         grid_z )
+                         ENDIF
+
+!
 !--                      Check for gust module quantities
                          IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
@@ -3034,4 +3064,13 @@
 
 !
+!--                   Check for biometeorology quantities
+                      IF ( .NOT. found  .AND.  radiation )  THEN
+                         CALL biometeorology_define_netcdf_grid( do2d(av,i),   &
+                                                            found,             &
+                                                            grid_x, grid_y,    &
+                                                            grid_z )
+                      ENDIF
+
+!
 !--                   Check for gust module quantities
                       IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
@@ -3694,4 +3733,13 @@
 
 !
+!--                   Check for biometeorology quantities
+                      IF ( .NOT. found  .AND.  radiation )  THEN
+                         CALL biometeorology_define_netcdf_grid( do2d(av,i),   &
+                                                            found,             &
+                                                            grid_x, grid_y,    &
+                                                            grid_z )
+                      ENDIF
+
+!
 !--                   Check for gust module quantities
                       IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 3322)
+++ palm/trunk/SOURCE/palm.f90	(revision 3337)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! (from branch resler)
+! Fix chemistry call
+! 
+! 3298 2018-10-02 12:21:11Z kanani
 ! - Minor formatting (kanani)
 ! - Added Call of date_and_time_init (Russo)
@@ -425,5 +429,5 @@
 !-- --> Needs to be moved!! What is the dependency about?
 ! IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-    IF ( air_chemistry  .AND.  do_emis )  THEN
+    IF ( air_chemistry )  THEN
 
        IF ( do_emis ) THEN
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3337)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Fix reading plant canopy over buildings
+! 
+! 3294 2018-10-01 02:37:10Z raasch
 ! ocean renamed ocean_mode
 ! 
@@ -1131,4 +1134,7 @@
        INTEGER(iwp)                        ::  i, j      !< running index
        INTEGER(iwp)                        ::  nzp       !< number of vertical layers of plant canopy
+       INTEGER(iwp)                        ::  nzpltop   !<
+       INTEGER(iwp)                        ::  nzpl      !<
+       INTEGER(iwp)                        ::  kk        !<
        
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  col   !< vertical column of input data
@@ -1144,5 +1150,6 @@
                  FORM='FORMATTED', ERR=515)
        READ(152, *, ERR=516, END=517)  nzp   !< read first line = number of vertical layers
-       
+       nzpltop = MIN(nzt+1, nzb+nzp-1)
+       nzpl = nzpltop - nzb + 1    !< no. of layers to assign
        ALLOCATE( col(0:nzp-1) )
 
@@ -1164,6 +1171,6 @@
                    CALL message( 'pcm_read_plant_canopy_3d', 'PA0349', 1, 2, 0, 6, 0 )
                 ENDIF
-                lad_s(0:nzp-1,j,i) = col(0:nzp-1) * lad_type_coef(pctype)
-                
+                kk = get_topography_top_index_ji( j, i, 's' )
+                lad_s(nzb:nzpltop-kk, j, i) = col(kk:nzpl-1)*lad_type_coef(pctype)
              CASE DEFAULT
                 WRITE(message_string, '(a,i2,a)')   &
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 3322)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 3337)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! (from branch resler)
+! Fix for chemistry call
+! 
+! 3302 2018-10-03 02:39:40Z raasch
 ! Stokes drift + wave breaking term added
 ! 
@@ -482,14 +486,14 @@
        lsp_usr = 1
 !
-!--    If required, calculate photolysis frequencies - 
-!--    UNFINISHED: Why not before the intermediate timestep loop?
-       IF ( intermediate_timestep_count ==  1 )  THEN
-          CALL photolysis_control
-       ENDIF
-!
 !--    Chemical reactions
        CALL cpu_log( log_point(82), '(chem react + exch_h)', 'start' )
   
        IF ( chem_gasphase_on ) THEN
+!
+!--       If required, calculate photolysis frequencies - 
+!--       UNFINISHED: Why not before the intermediate timestep loop?
+          IF ( intermediate_timestep_count ==  1 )  THEN
+             CALL photolysis_control
+          ENDIF
           DO  i = nxl, nxr
              DO  j = nys, nyn
